# BuildDocksToolbarWindow Struct Reference

Inheritance diagram for BuildDocksToolbarWindow:

## Public Member Functions
| BuildDocksToolbarWindow (const WindowDesc *desc, WindowNumber window_number)
virtual void | OnPaint ()
| The window must be repainted.
virtual void | OnClick (Point pt, int widget, int click_count)
| A click with the left mouse button has been made on the window.
virtual EventState | OnKeyPress (uint16 key, uint16 keycode)
| A key has been pressed.
virtual void | OnPlaceObject (Point pt, TileIndex tile)
| The user clicked some place on the map when a tile highlight mode has been set.
virtual void | OnPlaceDrag (ViewportPlaceMethod select_method, ViewportDragDropSelectionProcess select_proc, Point pt)
| The user is dragging over the map when the tile highlight mode has been set.
virtual void | OnPlaceMouseUp (ViewportPlaceMethod select_method, ViewportDragDropSelectionProcess select_proc, Point pt, TileIndex start_tile, TileIndex end_tile)
| The user has dragged over the map when the tile highlight mode has been set.
virtual void | OnPlaceObjectAbort ()
| The user cancelled a tile highlight mode that has been set.
virtual void | OnPlacePresize (Point pt, TileIndex tile_from)
| The user moves over the map when a tile highlight mode has been set when the special mouse mode has been set to 'PRESIZE' mode.

## Detailed Description

Definition at line 166 of file dock_gui.cpp.

## Member Function Documentation

virtual void BuildDocksToolbarWindow::OnClick | ( | Point | pt,
|  | int | widget,
|  | int | click_count |
| ) |  |  | `[inline, virtual]`

A click with the left mouse button has been made on the window.

Parameters:

  | pt | the point inside the window that has been clicked.
  | widget | the clicked widget.
  | click_count | Number of fast consecutive clicks at same position

Reimplemented from Window.

Definition at line 184 of file dock_gui.cpp.

References DTW_BUTTONS_BEGIN.

virtual EventState BuildDocksToolbarWindow::OnKeyPress | ( | uint16 | key,
|  | uint16 | keycode |
| ) |  |  | `[inline, virtual]`

A key has been pressed.

Parameters:

  | key | the Unicode value of the key.
  | keycode | the untranslated key code including shift state.

Returns:
  ES_HANDLED if the key press has been handled and no other window should receive the event.

Reimplemented from Window.

Definition at line 189 of file dock_gui.cpp.

References Window::ES_HANDLED, and Window::ES_NOT_HANDLED.

virtual void BuildDocksToolbarWindow::OnPaint | ( |  | ) | `[inline, virtual]`

The window must be repainted.

Note:
  This method should not change any state, it should only use drawing functions.

Reimplemented from Window.

Definition at line 178 of file dock_gui.cpp.

References CanBuildVehicleInfrastructure(), Window::DrawWidgets(), DTW_BUOY, DTW_DEPOT, DTW_STATION, Window::SetWidgetsDisabledState(), VEH_SHIP, and WIDGET_LIST_END.

virtual void BuildDocksToolbarWindow::OnPlaceDrag | ( | ViewportPlaceMethod | select_method,
|  | ViewportDragDropSelectionProcess | select_proc,
|  | Point | pt |
| ) |  |  | `[inline, virtual]`

The user is dragging over the map when the tile highlight mode has been set.

Parameters:

  | select_method | the method of selection (allowed directions)
  | select_proc | what will be created when the drag is over.
  | pt | the exact point on the map where the mouse is.

Reimplemented from Window.

Definition at line 211 of file dock_gui.cpp.

References VpSelectTilesWithMethod().

virtual void BuildDocksToolbarWindow::OnPlaceMouseUp | ( | ViewportPlaceMethod | select_method,
|  | ViewportDragDropSelectionProcess | select_proc,
|  | Point | pt,
|  | TileIndex | start_tile,
|  | TileIndex | end_tile |
| ) |  |  | `[inline, virtual]`

The user has dragged over the map when the tile highlight mode has been set.

Parameters:

  | select_method | the method of selection (allowed directions)
  | select_proc | what should be created.
  | pt | the exact point on the map where the mouse was released.
  | start_tile | the begin tile of the drag.
  | end_tile | the end tile of the drag.

Reimplemented from Window.

Definition at line 216 of file dock_gui.cpp.

References _ctrl_pressed, _settings_client, CcBuildBridge(), CMD_BUILD_BRIDGE, CMD_BUILD_CANAL, CMD_MSG, DDSP_BUILD_BRIDGE, DDSP_CREATE_RIVER, DDSP_CREATE_WATER, DDSP_DEMOLISH_AREA, DoCommandP(), ClientSettings::gui, GUIPlaceProcDragXY(), GUISettings::persistent_buildingtools, and TRANSPORT_WATER.

virtual void BuildDocksToolbarWindow::OnPlaceObject | ( | Point | pt,
|  | TileIndex | tile |
| ) |  |  | `[inline, virtual]`

The user clicked some place on the map when a tile highlight mode has been set.

Parameters:

  | pt | the exact point on the map that has been clicked.
  | tile | the tile on the map that has been clicked.

Reimplemented from Window.

Definition at line 206 of file dock_gui.cpp.

virtual void BuildDocksToolbarWindow::OnPlacePresize | ( | Point | pt,
|  | TileIndex | tile |
| ) |  |  | `[inline, virtual]`

The user moves over the map when a tile highlight mode has been set when the special mouse mode has been set to 'PRESIZE' mode.

An example of this is the tile highlight for dock building.

Parameters:

  | pt | the exact point on the map where the mouse is.
  | tile | the tile on the map where the mouse is.

Reimplemented from Window.

Definition at line 249 of file dock_gui.cpp.

References GetInclinedSlopeDirection(), GetTileSlope(), INVALID_DIAGDIR, ReverseDiagDir(), TileAddByDiagDir(), and VpSetPresizeRange().

The documentation for this struct was generated from the following file:

- src/dock_gui.cpp